FromNetASCIIInputStream
Date: 2016-06-23

org.apache.commons.net.io

## Class FromNetASCIIInputStream

- java.lang.Object
- - java.io.InputStream
  - - java.io.FilterInputStream
    - - java.io.PushbackInputStream
      - - org.apache.commons.net.io.FromNetASCIIInputStream

- All Implemented Interfaces:
    java.io.Closeable, java.lang.AutoCloseable

      public final class FromNetASCIIInputStream
      extends java.io.PushbackInputStream

  This class wraps an input stream, replacing all occurrences of <CR><LF> (carriage return followed by a linefeed), which is the NETASCII standard for representing a newline, with the local line separator representation. You would use this class to implement ASCII file transfers requiring conversion from NETASCII.

- - ### Field Summary

    - ### Fields inherited from class java.io.PushbackInputStream

      `buf, pos`

    - ### Fields inherited from class java.io.FilterInputStream

      `in`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `FromNetASCIIInputStream(java.io.InputStream input)` Creates a FromNetASCIIInputStream instance that wraps an existing InputStream.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `int` | `available()` Returns the number of bytes that can be read without blocking EXCEPT when newline conversions have to be made somewhere within the available block of bytes.
    `static boolean` | `isConversionRequired()` Returns true if the NetASCII line separator differs from the system line separator, false if they are the same.
    `int` | `read()` Reads and returns the next byte in the stream.
    `int` | `read(byte[] buffer)` Reads the next number of bytes from the stream into an array and returns the number of bytes read.
    `int` | `read(byte[] buffer, int offset, int length)` Reads the next number of bytes from the stream into an array and returns the number of bytes read.

    - ### Methods inherited from class java.io.PushbackInputStream

      `close, mark, markSupported, reset, skip, unread, unread, unread`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### FromNetASCIIInputStream

          public FromNetASCIIInputStream(java.io.InputStream input)

      Creates a FromNetASCIIInputStream instance that wraps an existing InputStream.
      Parameters:
        `input` - the stream to wrap

  - ### Method Detail

    - #### isConversionRequired

          public static final boolean isConversionRequired()

      Returns true if the NetASCII line separator differs from the system line separator, false if they are the same. This method is useful to determine whether or not you need to instantiate a FromNetASCIIInputStream object.
      Returns:
        True if the NETASCII line separator differs from the local system line separator, false if they are the same.

    - #### read

          public int read()
                   throws java.io.IOException

      Reads and returns the next byte in the stream. If the end of the message has been reached, returns -1. Note that a call to this method may result in multiple reads from the underlying input stream in order to convert NETASCII line separators to the local line separator format. This is transparent to the programmer and is only mentioned for completeness.
      Overrides:
        `read` in class `java.io.PushbackInputStream`
      Returns:
        The next character in the stream. Returns -1 if the end of the stream has been reached.
      Throws:
        `java.io.IOException` - If an error occurs while reading the underlying stream.

    - #### read

          public int read(byte[] buffer)
                   throws java.io.IOException

      Reads the next number of bytes from the stream into an array and returns the number of bytes read. Returns -1 if the end of the stream has been reached.
      Overrides:
        `read` in class `java.io.FilterInputStream`
      Parameters:
        `buffer` - The byte array in which to store the data.
      Returns:
        The number of bytes read. Returns -1 if the end of the message has been reached.
      Throws:
        `java.io.IOException` - If an error occurs in reading the underlying stream.

    - #### read

          public int read(byte[] buffer,
                 int offset,
                 int length)
                   throws java.io.IOException

      Reads the next number of bytes from the stream into an array and returns the number of bytes read. Returns -1 if the end of the message has been reached. The characters are stored in the array starting from the given offset and up to the length specified.
      Overrides:
        `read` in class `java.io.PushbackInputStream`
      Parameters:
        `buffer` - The byte array in which to store the data.
        `offset` - The offset into the array at which to start storing data.
        `length` - The number of bytes to read.
      Returns:
        The number of bytes read. Returns -1 if the end of the stream has been reached.
      Throws:
        `java.io.IOException` - If an error occurs while reading the underlying stream.

    - #### available

          public int available()
                        throws java.io.IOException

      Returns the number of bytes that can be read without blocking EXCEPT when newline conversions have to be made somewhere within the available block of bytes. In other words, you really should not rely on the value returned by this method if you are trying to avoid blocking.
      Overrides:
        `available` in class `java.io.PushbackInputStream`
      Throws:
        `java.io.IOException`